package org.jeecg.modules.stm.wb.manage.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
 
 
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.wb.manage.entity.WbCompanyCheckRule;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.jeecg.modules.stm.wb.manage.service.IWbCompanyCheckRuleService;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import java.util.Arrays;

 /**
 * @Description: wb_company_check_rule
 * @Author: jeecg-boot
 * @Date:   2024-03-09
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/wb.manage/wbCompanyCheckRule")
@Slf4j
public class WbCompanyCheckRuleController extends JeecgController<WbCompanyCheckRule, IWbCompanyCheckRuleService> {
	@Autowired
	private IWbCompanyCheckRuleService wbCompanyCheckRuleService;
	
	/**
	 * 分页列表查询
	 *
	 * @param wbCompanyCheckRule
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "wb_company_check_rule-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<WbCompanyCheckRule>> queryPageList(WbCompanyCheckRule wbCompanyCheckRule,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<WbCompanyCheckRule> queryWrapper = QueryGenerator.initQueryWrapper(wbCompanyCheckRule, req.getParameterMap());
		Page<WbCompanyCheckRule> page = new Page<WbCompanyCheckRule>(pageNo, pageSize);
		IPage<WbCompanyCheckRule> pageList = wbCompanyCheckRuleService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param wbCompanyCheckRule
	 * @return
	 */
	@AutoLog(value = "wb_company_check_rule-添加")
	  
	@RequiresPermissions("wb.manage:wb_company_check_rule:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody WbCompanyCheckRule wbCompanyCheckRule) {
		wbCompanyCheckRuleService.save(wbCompanyCheckRule);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param wbCompanyCheckRule
	 * @return
	 */
	@AutoLog(value = "wb_company_check_rule-编辑")
	  
	@RequiresPermissions("wb.manage:wb_company_check_rule:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody WbCompanyCheckRule wbCompanyCheckRule) {
		wbCompanyCheckRuleService.updateById(wbCompanyCheckRule);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "wb_company_check_rule-通过id删除")
	  
	@RequiresPermissions("wb.manage:wb_company_check_rule:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		wbCompanyCheckRuleService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "wb_company_check_rule-批量删除")
	  
	@RequiresPermissions("wb.manage:wb_company_check_rule:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.wbCompanyCheckRuleService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "wb_company_check_rule-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<WbCompanyCheckRule> queryById(@RequestParam(name="id",required=true) String id) {
		WbCompanyCheckRule wbCompanyCheckRule = wbCompanyCheckRuleService.getById(id);
		if(wbCompanyCheckRule==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(wbCompanyCheckRule);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param wbCompanyCheckRule
    */
    @RequiresPermissions("wb.manage:wb_company_check_rule:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, WbCompanyCheckRule wbCompanyCheckRule) {
        return super.exportXls(request, wbCompanyCheckRule, WbCompanyCheckRule.class, "wb_company_check_rule");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("wb.manage:wb_company_check_rule:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, WbCompanyCheckRule.class);
    }

}
